# 一个 最大的竖列，分子列前的竖列
class TalltyImportExport::ExportPayload::CellColumn
  attr_reader :header, :payload, :context, :cell_clusters, :flatten_cells, :tallest_cell_cluster

  def initialize header, value, context, &value_handler
    @header = header
    @value = value
    @context = context
    @cell_clusters = []
    @value_handler = value_handler

    val = @value_handler.call(@value.value, @header.as_json.symbolize_keys, keep_array: true)
    if (header.children&.length || 0) > 0 && val.is_a?(Array)
      @cell_clusters = val.map do |val|
        TalltyImportExport::ExportPayload::Cell.new(
          @header,
          TalltyImportExport::ExportPayload::Value.new(val, @value.chain),
          @context,
          &@value_handler
        )
      end
    else
      @cell_clusters = [
        TalltyImportExport::ExportPayload::Cell.new(
          @header,
          TalltyImportExport::ExportPayload::Value.new(
            @value_handler.call(@value.value, @header.as_json.symbolize_keys),
            @value.chain,
          ),
          @context,
          &@value_handler
        )
      ]
    end

    @flatten_cells = []

    cell_divise
  end

  def cell_divise
    divised_cell_clusters = @cell_clusters.map do |cell_cluster|
      cell_cluster.divise.cell_cluster
    end

    @flatten_cells = divised_cell_clusters.flatten

    depth_to_cells_mapping = @flatten_cells.group_by { |cell| [cell.header.seq] }

    @tallest_cell_cluster = depth_to_cells_mapping.values.max { |a, b| a.count <=> b.count } || []

    self
  end
end
